/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

// thanks to Apple for this really cool code so I haven't had to spend hours creating it myself. I love you Apple!


var kMenuSuffixes = new Array("mm", "dd", "yy");
/***********************************/
// AVAILABLE WEBSITES
/***********************************/
// 1- the kWebsites associated index name must match that element's array's first element
// 2- CODES to format URLS - see function formatURL
// 3- Each element[site ID, site URL (with codes - see 2){, array[name in client form, value (with codes - see 2), ...]}]

var kWebsites = new Array(0);
var kWebsiteOptions = new Array(0);

kWebsites["BookingWiz.com"] = new Array("BookingWiz.com", "http://www.bookingwiz.com/iframe_sb_redirect.asp?fm_mic=54tw13r&fm_datecalc=0&singleMenu=air&flightType=!w!&city1=!a1!&date1=!dm!/!dd!/!dy!&city2=!a2!&date2=!am!/!ad!/!ay!&adults=!a!&children=!c!&Submit=GET+BEST+DEALS");
kWebsiteOptions["BookingWiz.com"] = 0;



var kDepartureDate = new Date();
kDepartureDate.setDate(kDepartureDate.getDate() + 1);
var kArrivalDate = new Date(kDepartureDate);
kArrivalDate.setDate(kArrivalDate.getDate() + 7);

/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.
function setup()
{
	widget_vcheck_textdb("http://www.widgetizer.com/update.txt", "update_link", "id\\|version", ["airForm"]);
	setMenuDate("doa", kDepartureDate);
	setMenuDate("dod", kArrivalDate);
	
	adminFormGUI();
}



/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront"); // freezes the widget and prepares it for the flip back to the front
	}
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function getAirInfo(pWay) {
	document.getElementById("way").value = ((pWay == null) ? '2' : '1');
	var theURL = formatURL("BookingWiz.com");
	if (window.widget) widget.openURL(theURL);
	else window.location = theURL;
}

function addMonth(pInDate, pNbMonths){
	var vOutDate= new Date(pInDate);
	vOutDate.setMonth(pInDate.getMonth() + pNbMonths);
	if (vOutDate.getDate() < pInDate.getDate()) { vOutDate.setDate(0); }
	return vOutDate;
}
function addToDate(pInDate, pYearDelta, pMonthDelta, pDayDelta) {
	var vOutDate =  new Date(pInDate);
	if((pYearDelta != 0) || (pMonthDelta != 0) || (pDayDelta != 0)) {
		if (pYearDelta != 0) { vOutDate.setFullYear(vOutDate.getFullYear() + pYearDelta); }
		if (pMonthDelta != 0) { vOutDate = addMonth(vOutDate, pMonthDelta); }
		if (pDayDelta != 0) { vOutDate = new Date(vOutDate.getTime() + (pDayDelta * 24 * 60 * 60 * 1000)); }
	}
	
	return vOutDate;
}
function dropDownChanged(elem) {
	var doamm = window.document.airForm.doamm.value;
	var doadd = window.document.airForm.doadd.value;
	var doayy = window.document.airForm.doayy.value;
	var dodmm = window.document.airForm.dodmm.value;
	var doddd = window.document.airForm.doddd.value;
	var dodyy = window.document.airForm.dodyy.value;
	var vDuration = kArrivalDate.getTime() - kDepartureDate.getTime();
	
	if(doamm && doadd && doayy && dodmm && doddd && dodyy) {
		//var doa = ("" + doayy) + doamm + doadd; // Departure -- REMOVED 11-14-05
		//var dod = ("" + dodyy) + dodmm + doddd; // Arrival -- REMOVED 11-14-05
		
		// ADJUST date objects
		if(elem.id == "doadd") {
			kDepartureDate = addToDate(kDepartureDate, 0, 0, (doadd - kDepartureDate.getDate()));
		} else if(elem.id == "doamm") {
			kDepartureDate = addToDate(kDepartureDate, 0, (doamm - (kDepartureDate.getMonth() + 1)), 0);
		} else if(elem.id == "doayy") {
			kDepartureDate = addToDate(kDepartureDate, (doayy - kDepartureDate.getFullYear()), 0, 0);
			if(kDepartureDate.getFullYear() < parseInt(window.document.airForm.doayy.options[0])) kDepartureDate.setFullYear(parseInt(window.document.airForm.doayy.options[0]));
		} else if(elem.id == "doddd") {
			kArrivalDate = addToDate(kArrivalDate, 0, 0, (doddd - kArrivalDate.getDate()));
		} else if(elem.id == "dodmm") { 
			kArrivalDate = addToDate(kArrivalDate, 0, (dodmm - (kArrivalDate.getMonth() + 1)), 0);
		} else if(elem.id == "dodyy") {
			kArrivalDate = addToDate(kArrivalDate, (dodyy - kArrivalDate.getFullYear()), 0, 0);
		}
		
		//if(doa > dod) {  -- REMOVED 11-14-05
		if(kDepartureDate.getTime() > kArrivalDate.getTime()) { // Departure AFTER arrival...
			if((elem.id == "doamm") || (elem.id == "doadd") || (elem.id == "doayy")) {
				kArrivalDate = new Date(kDepartureDate.getTime());
				setMenuDate("dod", kArrivalDate);
			} else {
				kDepartureDate = new Date(kArrivalDate.getTime());
				setMenuDate("doa", kDepartureDate);
			}
		}
		/*if(kDepartureDate.getTime() > kArrivalDate.getTime()) { // Departure AFTER arrival...
			if((elem.id == "doamm") || (elem.id == "doadd") || (elem.id == "doayy")) {
				kArrivalDate = new Date(kDepartureDate.getTime() + vDuration);
				if(kArrivalDate.getFullYear() < parseInt(window.document.airForm.dodyy.options[0].value)) { // -- ADDED 11-14-05
					kArrivalDate = new Date(kDepartureDate);
				}
				setMenuDate("dod", kArrivalDate);
			} else {
				kDepartureDate = new Date(kArrivalDate.getTime() - vDuration);
				if(kDepartureDate.getFullYear() < parseInt(window.document.airForm.doayy.options[0].value)) { // -- ADDED 11-14-05
					kDepartureDate = new Date(kArrivalDate);
				}
				setMenuDate("doa", kDepartureDate);
			}
		}*/
	}
	
	if((elem.id == "doamm") || (elem.id == "doadd") || (elem.id == "doayy")) {
		setMenuDate("doa", kDepartureDate);
	} else {
		setMenuDate("dod", kArrivalDate);
	}
}
function adminFormGUI() {
	document.getElementById("fltbox_submit").disabled = ((document.getElementById("airport1").value == null) || (document.getElementById("airport1").value == "") || (document.getElementById("airport2").value == null) || (document.getElementById("airport2").value == ""));
}
function setMenuDate(pMenuPrefix, pDate) {
	var vMenu;
	for(var j = 0; j < kMenuSuffixes.length; j++) {
		vMenu = document.getElementById(pMenuPrefix + kMenuSuffixes[j]);
		if(kMenuSuffixes[j] == "mm") {
			vMenu.options[pDate.getMonth()].selected = true;
		} else if (kMenuSuffixes[j] == "dd") {
			vMenu.options[pDate.getDate() - 1].selected = true;
		} else if (kMenuSuffixes[j] == "yy") {
			vMenu.options[pDate.getFullYear() - 2010].selected = true;
		}
		document.getElementById(vMenu.id+"Span").innerText = vMenu.options[vMenu.selectedIndex].text;
	}
}

function setAdults(choice) {
	document.getElementById("adultsDisplay").innerHTML = choice.options[choice.selectedIndex].text;
}

function setChild(choice) {
	document.getElementById("childDisplay").innerHTML = choice.options[choice.selectedIndex].text;
}


function formatString(pString) {
/*
	!a! = Nb of Adults
	!c! = Nb of children
	!p! = Nb of passengers ( == !a! + !c!)
	!a1! = Departure airport (code OR city)
	!dy! = Departure year
	!dys! = Departure year (short: 05)
	!dm! = Departure month
	!dma! = Departure month abbrev. ("Jan", "Feb"...)
	!dd! = Departure day
	!a2! = Arrival airport (code OR city)
	!ay! = Arrival year
	!ays! = Arrival year (short: 05)
	!am! = Arrival month
	!ama! = Arrival month abbrev. ("Jan", "Feb"...)
	!ad! = Arrival day
*/
	var vResult = pString;
	vResult = vResult.replace(/\!a\!/gi, window.document.airForm.adults.value);
	vResult = vResult.replace(/\!c\!/gi, window.document.airForm.children.value);
	vResult = vResult.replace(/\!p\!/gi, parseInt(window.document.airForm.adults.value) + parseInt(window.document.airForm.children.value));
	vResult = vResult.replace(/\!w\!/gi, parseInt(window.document.airForm.way.value));
	
	vResult = vResult.replace(/\!a1\!/gi, window.document.airForm.airport1.value);
	vResult = vResult.replace(/\!dy\!/gi, window.document.airForm.doayy.value);
	vResult = vResult.replace(/\!dys\!/gi, ("" + window.document.airForm.doayy.value).substring(2));
	vResult = vResult.replace(/\!dm\!/gi, window.document.airForm.doamm.value);
	vResult = vResult.replace(/\!dma\!/gi, window.document.airForm.doamm[window.document.airForm.doamm.selectedIndex].value);
	vResult = vResult.replace(/\!dd\!/gi, window.document.airForm.doadd.value);
	
	vResult = vResult.replace(/\!a2\!/gi, window.document.airForm.airport2.value);
	vResult = vResult.replace(/\!ay\!/gi, window.document.airForm.dodyy.value);
	vResult = vResult.replace(/\!ays\!/gi, ("" + window.document.airForm.dodyy.value).substring(2));
	vResult = vResult.replace(/\!am\!/gi, window.document.airForm.dodmm.value);
	vResult = vResult.replace(/\!ama\!/gi, window.document.airForm.dodmm[window.document.airForm.dodmm.selectedIndex].value);
	vResult = vResult.replace(/\!ad\!/gi, window.document.airForm.doddd.value);
	
	return vResult;
}
function formatURL(pSiteID, pOneWay) {
	var vResult = kWebsites[pSiteID][1];
	if(kWebsites[pSiteID].length <= 2) { // direct call - webiste expects GET request
		vResult = formatString(vResult);
	} else { // transform to POST request through 
		var vArguments = new Array();
		for(var i = 0; i < kWebsites[pSiteID][2].length; i = i + 2) {
			vArguments[vArguments.length] = (kWebsites[pSiteID][2][i] + "=" + formatString(kWebsites[pSiteID][2][i+1]));
		}
		if(window.widget) {
			vResult = "file://" + escape(widget.system("/bin/pwd", null).outputString).replace(/\%0A/i, "") + "/get2post.html?"+formatString(vResult) + "&" + vArguments.join("&");
		} else {
			vResult = "http://www.dashboardwidgets.com/widgetbackend/makePost.htm?"+escape(vResult) + "&" + vArguments.join("&");
		}
	}
	
	return vResult;
}

function setCurrentSite(pSiteID) {
	var vIndex = -1;
	for(var vURL in kWebsites) {
		vIndex++;
		if(kWebsites[vURL][0] == pSiteID) {
			// Adjust GUI according to options:
			var vAdultsLabel = document.getElementById("adultsLabel");
			var vChildrenLabel = document.getElementById("childLabel");
			var vChildrenPopupDisplay = document.getElementById("childDisplay");
			var vChildrenPopup = document.getElementById("childSelect");
			if(kWebsiteOptions[pSiteID] != 0) {
				vAdultsLabel.innerText = "# Tickets";
				vChildrenLabel.style.display = "none";
				vChildrenPopupDisplay.style.display = "none";
				vChildrenPopup.style.display = "none";
				vChildrenPopup.selectedIndex = 0;
				setChild(vChildrenPopup);
			} else {
				vAdultsLabel.innerText = "# Adults";
				vChildrenLabel.style.display = "inline";
				vChildrenPopupDisplay.style.display = "inline";
				vChildrenPopup.style.display = "inline";
			}
			
			break;
		}
	}
}